local expandhitboxes = CV_RegisterVar({name = "fangexpandhitboxes", defaultvalue = "On", flags = CV_NETVAR|CV_CHEAT, PossibleValue = {Off = 0, On = 1}})

mobjinfo[MT_CORK].speed = 1 //Balance tweak to preserve some of the challenge'
mobjinfo[MT_CORK].flags = $|MF_NOGRAVITY

addHook("MobjSpawn",function(mo)
	return true //Overwrite default behavior so that corks won't damage invulnerable players
end,MT_CORK)

//Add ghost trail to the cork to improve its visibility
addHook("MobjThinker",function(mo)
	if mo.flags&MF_MISSILE and mo.target and mo.target.player then
		local ghost = P_SpawnGhostMobj(mo)
		ghost.destscale = 0
		if not(gametyperules&GTR_FRIENDLY) //Add color trail to competitive gametypes
			ghost.colorized = true
			ghost.color = mo.target.player.skincolor
		end
		
		if not expandhitboxes.value
			return end
		
		searchBlockmap("objects",function(r,f)
			if not (r and f
			and (f.flags & MF_ENEMY
			or f.flags & MF_SHOOTABLE))
			or f == r.target
				return end
			
			local fheight = f.height * 2
			local rcenter = r.z + (r.height/2)
			local fcenter = f.z + (fheight/2)
			
			if R_PointToDist2(r.x,r.y,f.x,f.y) <= r.radius + (f.radius*3/2)
			and abs(rcenter-f.z) <= r.radius + fheight
				P_MoveOrigin(r,f.x,f.y,f.z)
			end
		end, mo)
	end
end,MT_CORK)